chemistry_starters/views/safety_checklist.py
"""
Defines the application's endpoints
"""
import datetime

from flask import (
    Blueprint,
    g,
    redirect,
    render_template,
    request,
    send_file,
    send_from_directory,
    url_for,
)

from chemistry_starters import app, database, utils
from chemistry_starters.forms import static_forms
from chemistry_starters.utils import comms, control
from chemistry_starters.utils.safety import is_safety_handbook_file_available

safety_checklist = Blueprint("safety_checklist", __name__)


@safety_checklist.route("/register/safety", methods=["GET", "POST"])
def redirect_safety():
    return redirect(url_for(".safety_checklist_form", token=request.args.get("token")))


@safety_checklist.route("/register/safety_checklist", methods=["GET", "POST"])
@utils.check_token()
def safety_checklist_form():
    uuid, role = utils.decode_token()
    try:
        (
            form_data,
            safety_already_submitted,
            main_form_submitted,
        ) = utils.safety.load_safety_form(uuid)
    except database.DatabaseNotAvailable:
        return redirect(url_for("error_pages.unavailable"))
    starter_name = database.name_for_uuid(uuid)
    if not main_form_submitted:
        return redirect(
            url_for(
                "person_role_details.person_role_details_form",
                token=request.args.get("token"),
            )
        )
    if safety_already_submitted:
        return redirect(
            url_for(
                "starter_navigation.navigation_index", token=request.args.get("token")
            )
        )
    safety_training_html = database.get_safety_training_html_for_uuid(uuid)

    from chemistry_starters.forms import safety_forms as forms

    if form_data is None:
        form_data = {}
    if safety_training_html is None:
        safety_form = forms.SafetyChecklist(data=form_data)
    else:
        safety_form = forms.SafetyChecklistWithTraining(data=form_data)
    if request.method == "GET":
        return render_template(
            "safety/safety_form.html",
            form=safety_form,
            starter_name=starter_name,
            safety_training_html=safety_training_html,
            safety_handbook_available=is_safety_handbook_file_available(),
        )
    else:
        if request.form.get("submit") != "Check data and submit form":
            safety_form.safety_submitted.data = False
            utils.safety.save_safety_form_state(uuid, safety_form)
            return render_template(
                "safety/safety_form.html",
                form=safety_form,
                starter_name=starter_name,
                safety_training_html=safety_training_html,
                safety_handbook_available=is_safety_handbook_file_available(),
            )
        else:
            if safety_form.validate_on_submit():
                utils.safety.save_safety_form_state(uuid, safety_form)
                worked = utils.safety.save_rendered_safety_form(
                    uuid, safety_form, starter_name
                )
                if worked:
                    utils.mail_safety_induction_signoff(uuid)
                    comms.mail_form_creator_on_progress(uuid)
                    return redirect(
                        url_for(
                            "starter_navigation.navigation_index",
                            token=request.args.get("token"),
                        )
                    )
                else:
                    return render_template("safety/safety_failed_to_save.html"), 500
            else:
                safety_submit_box_state = safety_form.safety_submitted.data
                safety_form.safety_submitted.data = False
                utils.safety.save_safety_form_state(uuid, safety_form)
                # Reset the submitted flag for the UI
                safety_form.safety_submitted.data = safety_submit_box_state
                return render_template(
                    "safety/safety_form.html",
                    incomplete=True,
                    form=safety_form,
                    starter_name=starter_name,
                    safety_training_html=safety_training_html,
                    safety_handbook_available=is_safety_handbook_file_available(),
                )


@safety_checklist.route("/sign/safety", methods=["GET", "POST"])
def redirect_safety_signer():
    return redirect(
        url_for(".safety_checklist_signoff", token=request.args.get("token"))
    )


@safety_checklist.route("/sign/safety_checklist", methods=["GET", "POST"])
@utils.check_acl()
@utils.check_token(salt="safety_checklist")
def safety_checklist_signoff():
    """
    To allow a group member to sign off a safety checklist
    """
    uuid, role = utils.decode_token(salt="safety_checklist")
    # load the uuid and check form has not been signed
    try:
        person_to_sign = utils.safety.get_safety_checklist_signer_crsid(uuid)
        if person_to_sign != g.crsid:
            return render_template("safety/wrong_safety_signer.html"), 503
        already_signed = utils.safety.is_safety_checklist_signed(uuid)
        if already_signed:
            return render_template(
                "safety/safety_checklist_signed_off.html",
                starter_name=database.name_for_uuid(uuid),
                signer_name=database.name_for_person(g.crsid),
                registration_complete=control.is_registration_complete(uuid),
            )
    except database.DatabaseNotAvailable:
        return redirect(url_for("error_pages.unavailable"))
    safety_signoff_form = static_forms.SafetyInductionSignOffForm()
    # if GET offer up the form
    if (request.method == "GET") or (not safety_signoff_form.validate_on_submit()):
        # Generate a token for fetching the PDF form
        checklist_token = utils.generate_token_for_form(
            form_type="rendered_safety_checklist",
            form_uuid=uuid,
            salt="rendered_safety_checklist",
        )
        return render_template(
            "safety/safety_checklist_sign.html",
            form=safety_signoff_form,
            starter_name=database.name_for_uuid(uuid),
            signer_name=database.name_for_person(g.crsid),
            form_url=url_for(
                ".get_completed_safety_form", _external=True, token=checklist_token
            ),
        )
    else:
        database.save_form_column(
            "safety_induction_signed_off_date", datetime.date.today(), uuid
        )
        if control.is_registration_complete(uuid):
            utils.control.send_registration_to_admin_team(uuid)
        return render_template(
            "safety/safety_checklist_signed_off.html",
            starter_name=database.name_for_uuid(uuid),
            signer_name=database.name_for_person(g.crsid),
            registration_complete=control.is_registration_complete(uuid),
        )


@safety_checklist.route("/forms/completed/safety")
@utils.check_acl()
@utils.check_token(salt="rendered_safety_checklist")
def get_completed_safety_form():
    uuid, _ = utils.decode_token(salt="rendered_safety_checklist")
    try:
        if utils.safety.check_safety_checklist_access(uuid):
            memory_file = utils.safety.get_rendered_safety_checklist(uuid)
            return send_file(
                memory_file, as_attachment=True, download_name="checklist.pdf"
            )
        else:
            return redirect(url_for("error_pages.forbidden"))
    except database.DatabaseNotAvailable:
        return redirect(url_for("error_pages.unavailable"))


@safety_checklist.route("/register/safety-handbook")
@utils.check_token()
def safety_handbook():
    """
    Serve up the safety handbook

    This document is not in the static directory because it has to have access control.
    It must also not be committed to the code repository because the contents
    are secret. This route to download it is protected by token checking.
    """
    return send_from_directory(
        app.root_path + "/documents/", app.config["SAFETY_HANDBOOK_FILENAME"]
    )

chemistry_starters/templates/navigation/index.html
{% extends 'root.html' %}
{% block body %}
{% set personal_details_url =
url_for("person_role_details.person_role_details_form",_external=True,token=request.args.get("token")) %}
{% set safety_checklist_url =
url_for("safety_checklist.safety_checklist_form",_external=True,token=request.args.get("token")) %}
<h1>Chemistry Starters Registration</h1>
<p>Welcome to the Yusuf Hamied Department of Chemistry online registration system.</p>

<h3>Registration process progress</h3>

{# Things the starter still needs to complete #}
{% if not (person_role_form_complete and safety_checklist_complete) %}
<div class="tasks-to-be-done">
  <p><em>You need to carry out the following tasks:</em></p>
  <ul>
    {% if not person_role_form_complete %}
    <li class="undone">Complete and submit the personal details form at <a href="{{ personal_details_url }}">{{
        personal_details_url }}</a>
    </li>
    {% endif %}
    {% if not safety_checklist_complete %}
    <li class="undone">Have your safety induction meeting. The person who gave you the link to the online registration
      system should have told you how to arrange that.</li>
    {% if post_category is none %}<li class="undone">Possibly complete online safety training. Once the personal details
      form is complete this page and the safety checklist will be updated with details of any safety training you are
      required to complete.</li>{% else %}{% if safety_training_html is not none %}<li class="undone">Complete online
      safety training at {{ safety_training_html|safe }}</li>{% else %}<li>You do not need any additional safety training for your role</li>{%
    endif %}{% endif %}
    <li class="undone">Complete and submit the safety checklist form to confirm you have had a safety induction meeting
      and completed any safety training required for your role. {% if person_role_form_complete %}The checklist is at <a
        href="{{ safety_checklist_url }}">{{ safety_checklist_url }}</a> .{% else %}The checklist will become available
      from this page once the personal details form is submitted.{% endif %}</li>
    </li>
    {% endif %}

  </ul>
</div>
{% endif %}


{# things third parties still need to do #}
{% if (safety_training_signoff_needed and not safety_training_signed) or (safety_checklist_complete and not
safety_checklist_signed) %}
<div class="tasks-to-be-done">
  <p><em>Before your registration can be processed other people must carry out the following tasks</em>:</p>
  <ul>
    {% if not safety_checklist_signed %}
    <li>Once you have submitted the safety checklist it needs to be signed off as correct by {% if
      safety_checklist_checker is not none %}{{ safety_checklist_checker }}{% else %}the person who carried out your
      safety induction{% endif %}.{% if safety_checklist_complete %} They have been emailed with a copy and asked to do
      this. If you think the email has been missed you can ask {{ safety_checklist_checker }} to visit <a
        href="{{ url_for("safety_checklist.safety_checklist_signoff",_external=True,token=safety_check_token) }}">{{
        url_for("safety_checklist.safety_checklist_signoff",_external=True,token=safety_check_token) }}</a> to do this
      instead.{% endif %}</li>
    {% endif %}
    {% if safety_training_signoff_needed and not safety_training_signed %}
    <li>Once you have submitted the safety checklist, the Graduate Education Office will check you have successfully
      completed the safety training at {{ safety_training_html|safe }}.</li>
    {% endif %}
  </ul>
</div>
{% endif %}



{# Things the starter has completed #}
{% if person_role_form_complete or safety_checklist_complete %}
<div class="tasks-to-be-done">
  <p>You have already completed these tasks:</p>
  <ul>
    {% if person_role_form_complete %}
    <li>Personal details form</li>
    {% endif %}
    {% if safety_checklist_complete %}
    <li>Safety checklist</li>
    {% endif %}
  </ul>
</div>
{% endif %}

{# Things 3rd parties have completed #}
{% if (safety_training_signoff_needed and safety_training_signed) or (safety_checklist_complete and
safety_checklist_signed) %}
<p>Other people have completed the following tasks:</p>
<ul>
  {% if (safety_training_signoff_needed and safety_training_signed) %}
  <li>The Graduate Education Office has checked you have successfully completed safety training.</li>
  {% endif %}
  {% if safety_checklist_complete and safety_checklist_signed %}
  <li>{{ safety_checklist_checker }} has signed off your safety checklist as correct.</li>
  {% endif %}
</ul>
{% endif %}


<h3>Photograph</h3>
<div class="tasks-maybe-to-be-done">
  <p class="maybe-done">It is a requirement that all new starters are photographed for Departmental purposes - <em>this
      applies even if you already have a Cambridge University card</em>.
    Please follow this link to make an appointment if you have not already: <a target="_blank" rel="noopener noreferrer"
      href="https://calendly.com/photography-reg/registration-photograph-1">https://calendly.com/photography-reg/registration-photograph-1</a>.
    Directions to Photography can be found <a target="_blank" rel="noopener noreferrer"
      href="https://www.ch.cam.ac.uk/photography/how-find-us">here</a>.
  </p>
</div>

<h3>What happens next</h3>

<p><em>Swipe card access and access to IT systems will only be granted after all registration steps are complete, your
    photograph has been taken, and the admin team have processed the data.</em></p>
{% endblock %}